// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: Fifo_mon_xactor
// PURPOSE: Provided the monitor function of transactions seen on the Fifo interface
class Fifo_mon_xactor extends vmm_xactor;
  virtual fifo_if f_if;
  Fifo_xactn_channel push_out_chan;
  Fifo_xactn cur_push_xactn;
  Fifo_xactn factory_xactn;

  function new(string             inst,
             int unsigned         stream_id = -1,
             virtual fifo_if      new_vir_if,
             Fifo_xactn_channel   new_push_out_chan=null);
      super.new("Fifo Monitor Xactor", inst, stream_id);
      this.f_if = new_vir_if;
      if (new_push_out_chan==null)
		this.push_out_chan=new("Fifo_mon_chan_0","channel");
	  else this.push_out_chan = new_push_out_chan;
  endfunction : new
  
  extern task main();
  extern task mon_push();
endclass : Fifo_mon_xactor

task Fifo_mon_xactor::main();
    `vmm_trace(log, "Inside Monitor");
    fork
      super.main();
   join_none
  
   this.mon_push();
 endtask : main

task Fifo_mon_xactor::mon_push();
  string msg;
  forever begin : mon_push_loop
    @(this.f_if.mon_cb);
    if (this.f_if.mon_cb.push === 1'b1) begin
      $cast(this.cur_push_xactn, factory_xactn.allocate());
      this.cur_push_xactn.data = this.f_if.mon_cb.data_in;
      this.cur_push_xactn.xactn_time = $time;
      $sformat(msg,"Found a PUSH Xactn at time %0t data %0h ",
               $time, this.cur_push_xactn.data);
      `vmm_trace(log, msg);
 
      this.push_out_chan.sneak(this.cur_push_xactn);
    end // if
    // else
    //     begin
    //       $sformat(msg," waiting in mon...%t", $time);
    //       `vmm_verbose(log, msg);
    //     end // else
  end : mon_push_loop
endtask : mon_push
  

  





