// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_test_pgm
// PURPOSE:  Test program for the FIFO

program automatic fifo_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
  `include "test.svh"
  //the include files + log + fifo_env_0 instantiation
  // Fifo_xactn_no_push fifo_xactn; // No push constraints
  //Fifo_xactn_no_pop fifo_xactn; // No pop constraints

  initial  
  begin  : initial_pgm
    // Build all components of an environment - testbench
    `vmm_note(log,"Start of Test");
	// Do the build step
	fifo_env_0.build();
    begin : factory_4_error_injection
      Inject_err2 inject_err; // ** New error injection
	  Fifo_xactn fifo_xactn; // fifo transaction class declaration
	  fifo_xactn = new();	  // Instantiation of transaction class 
	  inject_err=new();
  	  `vmm_trace(log, "redefine the env error injector");
	  fifo_env_0.fifo_cmd_xactor_0.factory_inject_err = inject_err;
      fifo_env_0.mon_0.factory_xactn=fifo_xactn;	  
    end : factory_4_error_injection  
	`vmm_trace(log, " Now continue with the remaining verifications steps");
    fifo_env_0.run();
    `vmm_note(log, "End of Test");
  end  : initial_pgm
endprogram : fifo_test_pgm
