// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: Inject_err
// PURPOSE: Determines when to inject an erro and how to corrupt the data

//class Inject_err extends vmm_data;
class Inject_err;

  import fifo_pkg::*;
  static vmm_log log = new("Inject_err", "class");

  rand inject_err_t inject_err;

  constraint cst_inject_err{
    inject_err dist {
      INJECT := 0,
      NO_INJECT :=100
   };
  } // cst_inject_err

//  extern virtual function word_t corrupt_data(word_t data);
  virtual function word_t corrupt_data(word_t data);
     word_t local_data;
     // local_data={{data[WIDTH-1:1], !data[0]}};
     local_data=data;  // no errors
     `vmm_trace(log,  $psprintf("data=%h, corrupted %h", data, local_data));
     corrupt_data=local_data;
  endfunction : corrupt_data 

endclass : Inject_err
  
// --------------------
    
class Inject_err2 extends Inject_err;

  constraint cst_inject_err{
    inject_err dist {
      INJECT := 5,
      NO_INJECT :=100
   };
  } // cst_inject_err

  virtual function word_t corrupt_data(word_t data);
     word_t local_data;
     local_data={{data[WIDTH-1:2], !data[1], data[0]}};
     `vmm_trace(log,  $psprintf("data=%h, corrupted %h", data, local_data));	
     corrupt_data=local_data;
  endfunction : corrupt_data
  
endclass : Inject_err2
  

