// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_test_pgm
// PURPOSE:  Test program for the FIFO

program automatic fifo_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
  //include files + log + fifo_env_0 instantiation
  `include "test.svh"
  
  initial 
  begin : test 
    // Build all components of an environment - testbench
    `vmm_note(log,"Start of Test");
	// Do the build first
	fifo_env_0.build();
	// modify the default environment for the fifo_env_0.randomized_obj
	begin : setting_up_the_factory_for_the_generator
	  // Declare an instance and instantiate desired transaction with constraints 
      Fifo_xactn_no_pop fifo_xactn; // No pop constraints
     // Fifo_xactn_no_push fifo_xactn_no_push; // no push
	  fifo_xactn=new();
   	  `vmm_trace(log, "Modifying reference of randomized_obj to NO POP");
      fifo_env_0.fifo_xactn_gen_0.randomized_obj=fifo_xactn;
	  // Setting up the fifo_xactn for the monitor
      fifo_env_0.mon_0.factory_xactn=fifo_xactn; 
	end : setting_up_the_factory_for_the_generator
	// now run the environment.
	// Since the build was exercised already, it will not be repeated in the run 
    fifo_env_0.run();
    `vmm_note(log, "End of Test");
  end : test 
endprogram : fifo_test_pgm


