// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: Data_callback
// PURPOSE: Provides an error injection function and a special execution of an instruction 

typedef class Fifo_cmd_xactor; // forward reference 
virtual class Data_callback extends vmm_xactor_callbacks;
  import fifo_pkg::*;
virtual function void flip_data(ref word_t data);
  endfunction : flip_data 

  virtual task push_then_pop_task (
      Fifo_cmd_xactor xactor,
      word_t data,
      int  num_idle_cycles
              );
  endtask : push_then_pop_task
	
endclass : Data_callback
    // --------------------
    
class Data2_callback extends Data_callback;
   vmm_log log;
function void flip_data(ref word_t data);
    data={{data[WIDTH-1:2], !data[1], data[0]}};
    log=new("Data_callback", "class");
	`vmm_trace(log, $psprintf("data2_callback %b", data));
  endfunction : flip_data

  virtual task push_then_pop_task (Fifo_cmd_xactor xactor,
      word_t data,
      int  num_idle_cycles
              );
    begin
      log=new("Data_callback", "class");	  
      `vmm_trace(log, $psprintf ("%0t %m Push callback: data %0h ", $time, data));
	   xactor.f_if.driver_cb.data_in <= data;
	   xactor.f_if.driver_cb.push <= 1'b1;
	   xactor.f_if.driver_cb.pop  <= 1'b0;
	   @ ( xactor.f_if.driver_cb);
       xactor.f_if.driver_cb.push <= 1'b0;
      repeat (num_idle_cycles) @ ( xactor.f_if.driver_cb);       
      // pop
      `vmm_trace(log, $psprintf ("%0t %m Pop callback", $time));
      xactor.f_if.driver_cb.pop  <= 1'b1;
      xactor.f_if.driver_cb.push <= 1'b0;        
      @ ( xactor.f_if.driver_cb);
      xactor.f_if.driver_cb.pop  <= 1'b0;
    end
  endtask : push_then_pop_task
endclass : Data2_callback

class Data3_callback extends Data_callback;
function void flip_data(ref word_t data);
	log=new("Data_callback", "class");
     data={{~data[WIDTH-1:2], data[1], data[0]}};
     `vmm_trace(log, $psprintf("data3_callback %b", data));	
  endfunction : flip_data
endclass : Data3_callback  
