// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_test_pgm
// PURPOSE:  Test program for the FIFO
// This program is inserted into the testbench for the verification of the FIFO.
// The program represents the core of the test environment and includes the
// transaction generator and transactor.  
program automatic fifo_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
 `include "test.svh"
  
  initial
  begin
    // Build all components of an envrionment - testbench
    `vmm_note(log,"Start of Test");
	fifo_env_0.build();	
	begin
	  Fifo_xactn fifo_xactn; // fifo transaction class declaration
	  // Instantiation of transaction class 
      fifo_xactn = new();
     // Setting the factory for the monitor 
     fifo_env_0.mon_0.factory_xactn=fifo_xactn; 
	end 
     fifo_env_0.run();
   `vmm_note(log, "End of Test");	
  end
endprogram : fifo_test_pgm
