// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_pkg
// PURPOSE: Defines types.  
package fifo_pkg;
  timeunit 1ns; timeprecision 100ps;
 `define TOP fifo_tb
  typedef enum {PUSH, POP, PUSH_POP, IDLE, RESET} fifo_scen_t;
  typedef enum {PUSH_MODE, POP_MODE} mode_t;
  typedef enum {INJECT, NO_INJECT} inject_err_t;
  parameter BIT_DEPTH = 4;
  parameter FULL = 16;    
  parameter WIDTH = 32;
  typedef logic [WIDTH-1 : 0] word_t;
  typedef word_t [0 : (2**BIT_DEPTH-1)] buffer_t;
endpackage : fifo_pkg



