// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_tb
// PURPOSE: Top-level testbench that incorporates the DUT, the program, the interface, 
//          and the bind of the DUT to the property module.  
//          It also includes the generation of the clock.  
module fifo_tb;
  timeunit 1ns;
  timeprecision 100ps;

  logic clk = 1'b0;   // system clock
  logic  reset_n;

  fifo_if #(.setup_time(3), 
            .hold_time(3))  f_if(.*);		// instantiation of fifo interface

  fifo_test_pgm utest_pgm ();

  fifo fifo_rtl_1(.f_if(f_if), .*); // instantiation of fifo DUV

  bind fifo fifo_props fifo_props_1(clk, reset_n, f_if);

  // testbench code
   initial forever #50 clk = ~clk;

   initial
    begin
      $vcdpluson;
      $assertoff(0,fifo_tb);

    end

    always @(posedge clk)
	  if (!reset_n) $assertoff(0,fifo_tb);
      else $asserton(0,fifo_tb);
    
  
endmodule : fifo_tb
