// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: Debug_callback
// PURPOSE: callback to display Fifo_cmd_xactor to put class variables to a debug inerface

typedef class Fifo_cmd_xactor;
class Debug_callback extends vmm_xactor_callbacks;
import fifo_pkg::*; 

virtual task displayToDebug_if();
  //(counter_scen_t kind,  // kind of transaction
  //  inject_err_t err_inj);  // error Injection );
 endtask : displayToDebug_if

endclass : Debug_callback
  
class Debug2_callback  extends Debug_callback;
local Fifo_cmd_xactor             xactor;
virtual fifo_if.fdrvr_if_mp       f_if;
 virtual debug_if.driver_dbug_mp   dbug_if;
   
 function new(Fifo_cmd_xactor                   xactor, 
              virtual fifo_if.fdrvr_if_mp       new_vir_if, 
              virtual debug_if.driver_dbug_mp   dbug_if);
   this.xactor = xactor;
   this.f_if=new_vir_if;
   this.dbug_if = dbug_if;
 endfunction : new

  virtual task displayToDebug_if ();
      case (this.xactor.fifo_xactn_0.kind)
        PUSH     : this.dbug_if.driver_cb.kind <= PUSH;
        POP      : this.dbug_if.driver_cb.kind <= POP;
        PUSH_POP : this.dbug_if.driver_cb.kind <= PUSH_POP;
        IDLE     : this.dbug_if.driver_cb.kind <= IDLE;
		RESET    : this.dbug_if.driver_cb.kind <= RESET;
      endcase

      if (this.xactor.inject_error0.inject_err==INJECT)
        this.dbug_if.driver_cb.err_inj <= INJECT;
      else this.dbug_if.driver_cb.err_inj <= NO_INJECT;
      this.dbug_if.driver_cb.vgdata_in <= this.xactor.fifo_xactn_0.data;
      this.dbug_if.driver_cb.data_in <= this.xactor.ldata;
  endtask : displayToDebug_if

	
    
endclass : Debug2_callback

