// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: debug_if
// PURPOSE: Interface for display of information from a class

interface debug_if(input clk, 
                   input rst_n,
                   fifo_if f_if);
  timeunit 1ns; timeprecision 100ps;
  import fifo_pkg::*;
  word_t  data_in;	// in : data to load
  word_t vgdata_in;  // from original transaction generator
  fifo_scen_t kind;  // kind of transaction
  inject_err_t err_inj;  // error Injection 

  parameter hold_time=3;  
  parameter setup_time = 5;

  clocking driver_cb @(posedge clk);
    default input #setup_time output #hold_time;
    output data_in;
    output vgdata_in; // from original transaction generator
    output kind;
    output err_inj;
  //  typedef enum {IDLE, LOAD_DATA, ENABLE_COUNT, RESET} fifo_scen_t;
 //    property p_load;
//           word_t v_data_in;
//           (kind==LOAD_DATA, v_data_in=data_in) |=> data_in==f_if.count_out;
//     endproperty : p_load

  endclocking : driver_cb
    
 //    // ignoring the resets 
    property p_PUSH;
       @(posedge clk)
         kind==PUSH |-> f_if.push && !f_if.pop;
    endproperty : p_PUSH
    ap_PUSH: assert property(p_PUSH);

    property p_POP;
       @(posedge clk)
         kind ==POP |-> f_if.pop && !f_if.push;
    endproperty : p_POP
    ap_POP : assert property(p_POP);
     
  modport driver_dbug_mp(clocking driver_cb);



endinterface : debug_if
