// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: Inject_err
// PURPOSE: Determines when to inject an error 

class Inject_err extends vmm_data;
  import fifo_pkg::*;
  static vmm_log log = new("Inject_err", "class");

  rand inject_err_t inject_err;

  constraint cst_inject_err{
    inject_err dist {
      INJECT := 5,
      NO_INJECT :=100
   };
  } // cst_inject_err

  function new();
    super.new(this.log);
  endfunction : new		

  extern virtual function Inject_err allocate();		

//  extern virtual function word_t flip_data(word_t data);
  virtual function word_t flip_data(word_t data);
     word_t local_data;
     local_data={{data[WIDTH-1:1], !data[0]}};
     `vmm_trace(log,  $psprintf("data=%h, flipped %h", data, local_data));
     flip_data=local_data;
  endfunction : flip_data 

endclass : Inject_err
  
function Inject_err Inject_err::allocate();
    Inject_err err_local=new;
    `vmm_trace(log, "Inject_err allocated");      
    allocate = err_local;
endfunction : allocate
    
// function word_t Inject_err::flip_data(word_t data);
//      word_t local_data;
//      local_data={{data[WIDTH-1:1], !data[0]}};
//      `vmm_trace(log,  $psprintf("data=%h, flipped %h", data, local_data));
//      flip_data=local_data;
// endfunction : flip_data 



    // --------------------
    
class Inject_err2 extends Inject_err;

  extern virtual function Inject_err allocate();		

//  extern virtual function word_t flip_data(word_t data);
  virtual function word_t flip_data(word_t data);
     word_t local_data;
     local_data={{data[WIDTH-1:2], !data[1], data[0]}};
     `vmm_trace(log,  $psprintf("data=%h, flipped %h", data, local_data));	
     flip_data=local_data;
  endfunction : flip_data
  
endclass : Inject_err2
  
function Inject_err Inject_err2::allocate();
    Inject_err2 err_local=new;
    `vmm_trace(log, "Inject_err2 allocated");    	
    allocate = err_local;
endfunction : allocate
    
// function word_t Inject_err2::flip_data(word_t data);
//      word_t local_data;
//      local_data={{data[WIDTH-1:2], !data[1], data[0]}};
//      `vmm_trace(log,  $psprintf("data=%h, flipped %h", data, local_data));	
//      flip_data=local_data;
// endfunction : flip_data

