// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_test_pgm
// PURPOSE:  Test program for the FIFO
// This program is inserted into the testbench for the verification of the FIFO.
// The program represents the core of the test environment and includes the
// transaction generator and transactor.  
program automatic fifo_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
  import fifo_pkg::*;
  `include "test.svh"
  //the include files + log + fifo_env_0 instantiation

  initial
  begin
    // Build all components of an environment - testbench
    `vmm_note(log,"Start of Test");
	fifo_env_0.build();
    begin : factory_4_monitor 
	  Fifo_xactn fifo_xactn; // fifo transaction class declaration
	  fifo_xactn = new();	  // Instantiation of transaction class 
      fifo_env_0.mon_0.factory_xactn=fifo_xactn;	  
    end : factory_4_monitor
	  
    fifo_env_0.run();
    `vmm_note(log, "End of Test");
  end
endprogram : fifo_test_pgm
