// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: fifo_pkg
// PURPOSE: Defines types.  

package fifo_pkg;
  timeunit 1ns; timeprecision 100ps;
`define RESET 0
  `define TOP fifo_tb
  typedef enum {PUSH, POP, PUSH_POP, IDLE, RESET} fifo_scen_t;
  typedef enum {PUSH_MODE, POP_MODE} mode_t;
  typedef enum {PASSED, FAILED} fifo_status_t;
  typedef enum {DONE_GEN, DONE_BFM} notification_e;
  //  int DONE_GEN=1;
  parameter BIT_DEPTH = 4;
  parameter FULL = 16;    
  parameter WIDTH = 32;
  typedef   logic [WIDTH-1 : 0] word_t;
  typedef   logic[31:0] wword_t;
  typedef   logic [WIDTH-1 : 0] wire_word_t;
  typedef   word_t [0 : (2**BIT_DEPTH-1)] buffer_t;

  parameter 		 ALM_EMPTY_REG = 2'b00;
  parameter 		 ALM_FULL_REG = 2'b01;


endpackage : fifo_pkg



