// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: eth_test_pgm
// PURPOSE:  Test program for the Ethernet

program automatic eth_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
`include "vmm.sv"
`include "eth_broadcaster_env.sv"
parameter NUM_BCAST = 8;

  vmm_log log;
  Eth_env eth_env_0;

  initial
    begin : b1
      int unsigned iter = 0;
      
    // Build all components of an envrionment - testbench
    log = new("Pgm_Logger",0);
    eth_env_0 = new(); 
    `vmm_note(log,"Started");
    eth_env_0.build();
    
    eth_env_0.eth_des_channel_array = new[NUM_BCAST];
    eth_env_0.eth_asink_array = new[NUM_BCAST];
    foreach (eth_env_0.eth_des_channel_array [id]) begin: fe_loop_0
      eth_env_0.eth_des_channel_array[id] = new("eth_des_channel_array",
					   $psprintf("%0d", id));
      eth_env_0.eth_asink_array[id] = 
				      new("Artificial Sink", iter,
					  eth_env_0.eth_des_channel_array[id]);
      eth_env_0.eth_broadcaster.new_output
	(.channel(eth_env_0.eth_des_channel_array[id]), 
         .use_references(1));  
      iter++;
    end: fe_loop_0
   
    eth_env_0.run();
    `vmm_note(log,"DONE");
     #100 $finish;
     
    end : b1
endprogram : eth_test_pgm