`include "vmm.sv"
`include "test_cell.sv"

class test_cell extends vmm_data;

 test_cell_log_fmt log_fmt_cntl;

 static vmm_log log;

  function new(vmm_log n_log);
     super.new(this.log);
   this.log = n_log;
   this.log_fmt_cntl = new();
   this.log.set_format(this.log_fmt_cntl);
   endfunction : new
  task t2();
    `vmm_warning(this.log,"Packet about");
    `vmm_error(this.log,"data_integrity_error");
  endtask : t2
  
endclass : test_cell

program test;
test_cell cell ;
vmm_log log = new("s2p logger", "");
initial begin : b1
  int log_mod_id;
  cell = new(log);
  // Default warn/error
  cell.t2;
  `vmm_note(log,"Change from warning to error sev");
  // Demote warning to error
  log_mod_id = cell.log.modify(.name("/./"),
                               .severity(vmm_log::WARNING_SEV),
                               .new_severity(vmm_log::ERROR_SEV));

  cell.t2;
   `vmm_note(log,"Return to default error to warning sev");
  cell.log.unmodify(.modification_id(log_mod_id));
  cell.t2;
 
  #10;
   `vmm_note(log,"Change from  error to warning sev");
 
  // Demote error to warning
  log_mod_id = cell.log.modify(.name("/./"),
                               .severity(vmm_log::ERROR_SEV),
                               .new_severity(vmm_log::WARNING_SEV));

  cell.t2;
  `vmm_note(log,"Return to default error to warning sev");
  cell.log.unmodify(.modification_id(log_mod_id));
  cell.t2;
   $finish;
end
endprogram
