program s2p_test_pgm ();
  timeunit 1ns;
  timeprecision 100ps;
`include "vmm.sv"
`include "s2p_env.sv"

  vmm_log log;
  S2p_env s2p_env_0;
  int log_mod_id;

  initial
  begin : b1
    // Build all components of an envrionment - testbench
    log = new("Pgm_Logger",0);
    s2p_env_0 = new(); 
    `vmm_note(log,"Started");
    s2p_env_0.build();

     // Demotion
      log_mod_id = s2p_env_0.s2p_cmd_xactor_0.log.modify(.name("/s2p_xactn_log/"), 
			   .severity(vmm_log::ERROR_SEV),
			   .new_severity(vmm_log::WARNING_SEV));
    `vmm_note(log,"Demoted BFM Errors to Warning!");

    fork : f1
      s2p_env_0.run();
    join_none : f1
    repeat (4)
      s2p_env_0.s2p_atom_gen_0.notify.wait_for(S2p_xactn_atomic_gen::GENERATED);
    `vmm_note(log,"Reverting back the demotion");
    s2p_env_0.s2p_cmd_xactor_0.log.unmodify(log_mod_id);
    s2p_env_0.s2p_atom_gen_0.notify.wait_for(S2p_xactn_atomic_gen::DONE);
    #1000us;
        
    `vmm_note(log,"DONE");
     #100 $finish;
     
    end : b1
endprogram : s2p_test_pgm