class S2p_xactn extends vmm_data;

  rand logic [31:0] pkt_pld;
  rand logic err_pkt;
  rand bit [7:0] pkt_length;
  
  time xactn_time;
  
  constraint cst_no_err_pkt {
			     //err_pkt == 0;
			     } // cst_no_err_pkt

  static vmm_log log = new("s2p_xactn", "");

  function new();
    super.new(this.log);
  endfunction : new

  virtual function string psdisplay(string prefix = "");
  $sformat(psdisplay,
           "%s S2P %s Pkt, length %0d, data %0h",
           prefix,
	   this.err_pkt ? "ERROR" : "GOOD",
	   this.pkt_length, this.pkt_pld);
  endfunction : psdisplay
  
    extern virtual function  S2p_xactn copy(vmm_data cpy = null);
    

endclass:S2p_xactn

function  S2p_xactn S2p_xactn::copy(vmm_data cpy);
S2p_xactn local_xactn;

  if (cpy == null) begin
   local_xactn  = new;
  end
  else if (!$cast(local_xactn, cpy)) begin
    `vmm_fatal(log, "Attempting to copy a non s2p_xactn instance");
    copy = null;
    return;
  end

local_xactn.pkt_pld = this.pkt_pld;
local_xactn.err_pkt = this.err_pkt;
local_xactn.pkt_length = this.pkt_length;
return(local_xactn);
endfunction : copy
    
      // This macro declares new derived class named:
      // s2p_xactn_channel from vmm_channel
`vmm_channel (S2p_xactn)

