// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: s2p_top
// PURPOSE: Top-level testbench that incorporates the DUT, 
// the program, the interface, 
//          and the bind of the DUT to the property module.  
//          It also includes the generation of the clock. 

  timeunit 1ns;
  timeprecision 100ps;
module s2p_tb;

  logic clk = 1'b0;   // system clock
  logic  rst_n;

  s2p_if  s2p_if_0 (.*); // instantiation of s2p interface

  s2p_test_pgm utest_pgm ();

  ser2par dut_s2p (.par_data(s2p_if_0.par_data),.par_data_valid(s2p_if_0.par_data_valid),.ser_eop(s2p_if_0.ser_eop),.ser_data(s2p_if_0.ser_data),.ser_sop(s2p_if_0.ser_sop),.pkt_abort(s2p_if_0.ser_abort),.clk(clk),.rst_n(rst_n));

   initial forever #50 clk = ~clk;

   initial
    begin
      $vcdpluson;
    end
endmodule : s2p_tb
