// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: s2p_scenario_defn
// PURPOSE: The scenario definition for S2P

class S2p_scen_GP_EP extends S2p_xactn_scenario;

  int sc_id_alternate_GP_EP;

  function new();
    this.sc_id_alternate_GP_EP = define_scenario
				 (.name("Alternate Good & Error Pkt"),
				  .max_len(10));
    this.cst_no_err_pkt.constraint_mode(1'b0);
    
  endfunction : new

  // In base class S2p_xactn, there is a default constraint
  // that prevents err_pkt being generated. Since in this
  // scenario we need error pkt selectively, we override the
  // default one
  
  constraint cst_no_err_pkt {} // cst_no_err_pkt
  constraint cst_GP_EP 
  {
   if (this.scenario_kind == this.sc_id_alternate_GP_EP)
   {
    this.length == 10;
    this.repeated == 0;
    foreach (items [i])
    {
      (i%2) -> items[i].err_pkt == 0;
      !(i%2) -> items[i].err_pkt == 1;
    } // foreach
   } // if
  } // cst_GP_EP
endclass : S2p_scen_GP_EP

   