// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: s2p_asink
// PURPOSE: Artificial Sink

class S2p_asink extends vmm_xactor;
  S2p_xactn_channel in_chan;
  function new(string instance,
               int unsigned stream_id = -1,
               S2p_xactn_channel      new_in_chan);
      super.new("Artificial Sink", instance, stream_id);
      this.in_chan = new_in_chan;
  endfunction : new

  extern task main();
  extern task artificial_sink(S2p_xactn_channel chan);
  
endclass : S2p_asink

task S2p_asink::artificial_sink(S2p_xactn_channel chan);
S2p_xactn cur_tr;
assert ( chan != null) else begin : null_chan_guard
  `vmm_fatal (this.log, "A NULL channel was passed to task %m ");
  return;
end: null_chan_guard
while (1) begin:w_0
  chan.get(cur_tr);
  `vmm_note(this.log,cur_tr.psdisplay
	    (.prefix ("ASINK Sinking")));
end : w_0
endtask : artificial_sink

task S2p_asink::main();
  fork super.main();join_none
  artificial_sink(this.in_chan);
endtask : main
