// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: s2p_cmd_xactor
// PURPOSE: Transactor for the s2p

class S2p_cmd_xactor extends vmm_xactor;
  virtual s2p_if.ser_drv_mp s2p_if_0;
   
  vmm_log log;
  S2p_xactn_channel in_chan;
  function new(        string               instance,
                       int unsigned         stream_id = -1,
               virtual s2p_if.ser_drv_mp  new_vir_if,
               S2p_xactn_channel      new_in_chan = null);
      super.new("S2P_CMD_Xactor", instance, stream_id);
      this.s2p_if_0 = new_vir_if;
      this.in_chan = new_in_chan;
      this.log = new("s2p_xactn_log", "");
  endfunction : new

  extern task main();
  extern task send_ser_pkt(logic [31:0] data);

endclass: S2p_cmd_xactor

 task S2p_cmd_xactor::main();
    fork
      super.main();
    join_none
    forever
    begin : main_loop
      S2p_xactn  cur_xactn;
      this.in_chan.get(cur_xactn);
    `vmm_note(this.log, $psprintf("Got a new s2p xaction from in_channel %s ",
                                  cur_xactn.psdisplay()));
      this.send_ser_pkt(cur_xactn.pkt_pld);
    end : main_loop   
  endtask : main

  task S2p_cmd_xactor::send_ser_pkt (logic [31:0] data);
  begin
    this.s2p_if_0.ser_cb.ser_sop <= 1'b1;
    this.s2p_if_0.ser_cb.ser_eop <= 1'b0;
    this.s2p_if_0.ser_cb.ser_abort <= 1'b0;
    this.s2p_if_0.ser_cb.ser_data <= data[0];
    @ ( this.s2p_if_0.ser_cb);
    this.s2p_if_0.ser_cb.ser_sop <= 1'b0;
    for (int i=0; i <= 30; i++) begin : for_0
      this.s2p_if_0.ser_cb.ser_data <= data[i];
      @ ( this.s2p_if_0.ser_cb);
    end : for_0
    
    this.s2p_if_0.ser_cb.ser_data <= data[31];
    this.s2p_if_0.ser_cb.ser_eop <= 1'b1;
    @ ( this.s2p_if_0.ser_cb);
    this.s2p_if_0.ser_cb.ser_eop <= 1'b0;
    
  end
endtask : send_ser_pkt
