// VhdlCohen Publishing, copyright 2006 
// wwww.systemverilog.us  ben@systemverilog.us
// Code for use with the book 
// "A pragmatic Approach to Adopting VMM" ISBN 0-9705394-0-5
// NAME: s2p_if
// PURPOSE: Defines the fifo interface used by the RTL and the
//          testbench 
// --------------------------------------------------
// INTERFACE of S2P
interface s2p_if (input logic clk, rst_n);
   logic ser_data;
   logic ser_sop, ser_eop, ser_abort;
   logic [7:0] par_data;
   logic       par_data_valid;
   
   clocking ser_cb @ (posedge clk);
     output ser_data, ser_sop, ser_eop, ser_abort;
   endclocking : ser_cb
    
   modport ser_drv_mp (clocking ser_cb);
   
   clocking par_cb @ (posedge clk);
   output   par_data, par_data_valid;
   endclocking : par_cb
    
   modport par_drv_mp (clocking par_cb);
   
endinterface : s2p_if
